#ifdef GL_ES
// define default precision for float, vec, mat.
precision highp float;
#endif

//varying float brightOut;
varying vec4 colorOut;
varying vec4 colorAddOut;
varying vec2 texCoordOut;
uniform float grayRate;
uniform sampler2D texture;

void main()
{
    vec4 tex = colorOut * texture2D(texture, texCoordOut) + colorAddOut;
    float c = (tex.r + tex.g + tex.b) / 3.0;
    
    if (grayRate == 1.0)
    {
        gl_FragColor = vec4(c, c, c, tex.a);
    }
    else
    {
        vec4 pixel = vec4(c * grayRate + tex.r * (1.0 - grayRate),
                          c * grayRate + tex.g * (1.0 - grayRate),
                          c * grayRate + tex.b * (1.0 - grayRate), tex.a);
        gl_FragColor = pixel;
    }
}
