#ifdef GL_ES
// define default precision for float, vec, mat.
precision highp float;
#endif

//varying float brightOut;
varying vec4 colorOut;
varying vec4 colorAddOut;
varying vec2 texCoordOut;

uniform sampler2D texture;
uniform vec2 stepSize;

void main()
{
    // ** ignoring colorAdd
    if (colorOut.a == 0.0)
        discard;
    else
    {
        vec4 color = texture2D(texture, texCoordOut);
        
        // ** this requires at least 2 pixel gap for each images in texture.
        float stepX = stepSize.x * 1.0;
        float stepY = stepSize.y * 1.0;

        // * http://blogs.love2d.org/content/let-it-glow-dynamically-adding-outlines-characters
        // method1: inside-to-outside
        float alpha = color.a * 8.0;
        alpha -= (texture2D(texture, texCoordOut + vec2( stepX,     stepY ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( stepX,     0.0 ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( stepX,     -stepY ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( 0.0,       stepY ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( 0.0,       -stepY ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( -stepX,    stepY ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( -stepX,    0.0 ))).a;
        alpha -= (texture2D(texture, texCoordOut + vec2( -stepX,    -stepY ))).a;

        // method2: outside-to-inside
        /*
        float alpha = 0.0;
        alpha += (texture2D(texture, texCoordOut + vec2( stepX,     stepY ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( stepX,     0.0 ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( stepX,     -stepY ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( 0.0,       stepY ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( 0.0,       -stepY ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( -stepX,    stepY ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( -stepX,    0.0 ))).a;
        alpha += (texture2D(texture, texCoordOut + vec2( -stepX,    -stepY ))).a;
         //alpha /= 8.0;
         */
        
        alpha *= colorOut.a;
        
        gl_FragColor = vec4(alpha, alpha, alpha, alpha);
    }
}
